﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace AutoComplete
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "MeteringService" in both code and config file together.
    public class MeteringService : IMeteringService
    {
        public IList<Domain.MeteringData> GetData(string filter)
        {
            var meteringDatas = ListOfData().Where(p => p.Key.ToUpperInvariant().StartsWith(filter.ToUpperInvariant())).ToList();
            System.Threading.Thread.Sleep(1000);            /// To simulate a slow query
            return meteringDatas;
        }

        protected IList<Domain.MeteringData> ListOfData()
        {
            var meteringDatas = new List<Domain.MeteringData>();
            byte AChar = 0x41;
            for (byte i1=0; i1<26 ; i1++)
            {
                for (byte i2 = 0; i2 < 26; i2++)
                {
                    for (byte i3 = 0; i3 < 26; i3++)
                    {
                        for (byte i4 = 0; i4 < 26; i4++)
                        {
                            var byteArray = new byte[] {(byte)(i1+AChar), (byte)(i2+AChar), (byte)(i3+AChar), (byte)(i4+AChar)};
                            meteringDatas.Add(new Domain.MeteringData
                                                {
                                                    Key = System.Text.Encoding.Default.GetString(byteArray),
                                                    Description = string.Format("Message : {0}", System.Text.Encoding.Default.GetString(byteArray)),
                                                });
                        }
                    }
                }
            }
            return meteringDatas;
        }
    }
}
